/////////////////////////////////////////////////////////////////////////////
//
// Windows MFC Glk Libraries
//
// GlkDialogs
// Dialog classes
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "GlkDll.h"
#include "GlkDialogs.h"
#include "GlkTalk.h"
#include "GlkWindowTextBuffer.h"
#include "GlkWindowTextGrid.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Implementation of the CScrollBackDlg dialog
/////////////////////////////////////////////////////////////////////////////

CScrollBackDlg::CScrollBackDlg(CWnd* pParent) : CDialog(CScrollBackDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScrollBackDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CScrollBackDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScrollBackDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CScrollBackDlg, CDialog)
	//{{AFX_MSG_MAP(CScrollBackDlg)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_COPY, OnCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScrollBackDlg message handlers
/////////////////////////////////////////////////////////////////////////////

BOOL CScrollBackDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Subclass the text control
	if (m_RichEdit.SubclassDlgItem(IDC_TEXT,this) == FALSE)
		return FALSE;

	// Set the control to format the text so that it fits
	// into the window
	m_RichEdit.SetTargetDevice(NULL,0);
	
	// Set the background colour
	m_RichEdit.SetBackgroundColor(FALSE,GetSysColor(COLOR_3DFACE));

	// Put the text into the control
	m_RichEdit.SetWindowText(m_strScrollback);

	// Put the cursor at the end of the buffer
	m_RichEdit.SetSel(-1,-1);

	// Change the window icon
	SetIcon(AfxGetApp()->LoadIcon(IDR_GLK),TRUE);

	// Resize the dialog
	MoveWindow(m_DialogRect);

	return TRUE;
}

void CScrollBackDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	// Resize the text control
	if (m_RichEdit.GetSafeHwnd() != NULL)
		m_RichEdit.SetWindowPos(NULL,0,28,cx,cy-28,SWP_NOZORDER);
}

void CScrollBackDlg::OnCopy() 
{
	m_RichEdit.Copy();
}

/////////////////////////////////////////////////////////////////////////////
// CWinGlkLogoDlg dialog
/////////////////////////////////////////////////////////////////////////////

CWinGlkLogoDlg::CWinGlkLogoDlg(UINT nIDTemplate, CWnd* pParent) :
	CDialog(nIDTemplate,pParent), m_BitmapID(IDB_LOGO)
{
}

BEGIN_MESSAGE_MAP(CWinGlkLogoDlg, CDialog)
	//{{AFX_MSG_MAP(CWinGlkLogoDlg)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

BOOL CWinGlkLogoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if (m_BitmapID != 0)
		m_Dib.LoadBitmap(m_BitmapID);
	m_HollowBrush.CreateStockObject(HOLLOW_BRUSH);

	return TRUE;
}

BOOL CWinGlkLogoDlg::OnEraseBkgnd(CDC* pDC) 
{
	CDC dcMem;
	dcMem.CreateCompatibleDC(pDC);

	CRect ClientArea;
	GetClientRect(ClientArea);

	CBitmap Bmp;
	CSize Size(ClientArea.Width(),ClientArea.Height());
	if (Bmp.CreateCompatibleBitmap(pDC,Size.cx,Size.cy) == FALSE)
		return TRUE;
	CBitmap* pBmpOld = dcMem.SelectObject(&Bmp);

	dcMem.FillRect(ClientArea,CBrush::FromHandle(::GetSysColorBrush(COLOR_BTNFACE)));

	if ((dcMem.GetDeviceCaps(RASTERCAPS) & RC_PALETTE) == 0)
	{
		CPoint LogoPos(8,ClientArea.Height()-m_Dib.GetHeight()-8);
		m_Dib.DrawShaded(&dcMem,LogoPos,::GetSysColor(COLOR_BTNFACE),0.92);
	}

	pDC->BitBlt(0,0,Size.cx,Size.cy,&dcMem,0,0,SRCCOPY);
	dcMem.SelectObject(pBmpOld);

	return TRUE;
}

HBRUSH CWinGlkLogoDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	if (m_Dib.IsOK())
	{
		switch (nCtlColor)
		{
		case CTLCOLOR_STATIC:
			if (LOWORD(pWnd->GetDlgCtrlID()) == LOWORD(IDC_STATIC))
			{
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)m_HollowBrush;
			}
			break;
		}
	}
	return CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
}

/////////////////////////////////////////////////////////////////////////////
// CWinGlkLogoPage property page
/////////////////////////////////////////////////////////////////////////////

CWinGlkLogoPage::CWinGlkLogoPage(UINT nIDTemplate) :
	CPropertyPage(nIDTemplate), m_BitmapID(IDB_LOGO)
{
}

BEGIN_MESSAGE_MAP(CWinGlkLogoPage, CPropertyPage)
	//{{AFX_MSG_MAP(CWinGlkLogoPage)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

BOOL CWinGlkLogoPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	if (m_BitmapID != 0)
		m_Dib.LoadBitmap(m_BitmapID);
	m_HollowBrush.CreateStockObject(HOLLOW_BRUSH);

	return TRUE;
}

BOOL CWinGlkLogoPage::OnEraseBkgnd(CDC* pDC) 
{
	CDC dcMem;
	dcMem.CreateCompatibleDC(pDC);

	CRect ClientArea;
	GetClientRect(ClientArea);

	CBitmap Bmp;
	CSize Size(ClientArea.Width(),ClientArea.Height());
	if (Bmp.CreateCompatibleBitmap(pDC,Size.cx,Size.cy) == FALSE)
		return TRUE;
	CBitmap* pBmpOld = dcMem.SelectObject(&Bmp);

	dcMem.FillRect(ClientArea,CBrush::FromHandle(::GetSysColorBrush(COLOR_BTNFACE)));

	if ((dcMem.GetDeviceCaps(RASTERCAPS) & RC_PALETTE) == 0)
	{
		CPoint LogoPos(8,ClientArea.Height()-m_Dib.GetHeight()-8);
		m_Dib.DrawShaded(&dcMem,LogoPos,::GetSysColor(COLOR_BTNFACE),0.92);
	}

	pDC->BitBlt(0,0,Size.cx,Size.cy,&dcMem,0,0,SRCCOPY);
	dcMem.SelectObject(pBmpOld);

	return TRUE;
}

HBRUSH CWinGlkLogoPage::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	if (m_Dib.IsOK())
	{
		switch (nCtlColor)
		{
		case CTLCOLOR_STATIC:
			if (LOWORD(pWnd->GetDlgCtrlID()) == LOWORD(IDC_STATIC))
			{
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)m_HollowBrush;
			}
			else if (IsControlTransparent(pWnd->GetDlgCtrlID()))
			{
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)m_HollowBrush;
			}
			break;
		}
	}
	return CPropertyPage::OnCtlColor(pDC,pWnd,nCtlColor);
}

/////////////////////////////////////////////////////////////////////////////
// Option property sheets
/////////////////////////////////////////////////////////////////////////////

static void DDX_TextNoError(CDataExchange* pDX, int nIDC, int& value)
{
	char txt[256];
	HWND hWndCtrl = pDX->PrepareEditCtrl(nIDC);
	if (pDX->m_bSaveAndValidate)
	{
		::GetWindowText(hWndCtrl,txt,256);
		if (sscanf(txt,"%d",&value) != 1)
			value = 0;
	}
	else
	{
		sprintf(txt,"%d",value);
		::SetWindowText(hWndCtrl,txt);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWinGlkOptionGeneralPage property sheet
/////////////////////////////////////////////////////////////////////////////

CWinGlkOptionGeneralPage::CWinGlkOptionGeneralPage() :	CWinGlkLogoPage(CWinGlkOptionGeneralPage::IDD)
{
	//{{AFX_DATA_INIT(CWinGlkOptionGeneralPage)
	m_bBorders = FALSE;
	m_bLinkColour = FALSE;
	m_bUnderlineColour = FALSE;
	m_bGUI = FALSE;
	m_bStyleHints = FALSE;
	//}}AFX_DATA_INIT

	m_bSpeak = FALSE;
}

void CWinGlkOptionGeneralPage::DoDataExchange(CDataExchange* pDX)
{
	CWinGlkLogoPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinGlkOptionGeneralPage)
	DDX_Control(pDX, IDC_SPEECHDLG, m_OpenSpeechDlg);
	DDX_Control(pDX, IDC_USE_LINK_COLOUR, m_UseLinkColour);
	DDX_Check(pDX, IDC_BORDERS, m_bBorders);
	DDX_Check(pDX, IDC_USE_LINK_COLOUR, m_bLinkColour);
	DDX_Check(pDX, IDC_USE_LINK_UNDER, m_bUnderlineColour);
	DDX_Check(pDX, IDC_GUI, m_bGUI);
	DDX_Check(pDX, IDC_STYLEHINT, m_bStyleHints);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinGlkOptionGeneralPage, CWinGlkLogoPage)
	//{{AFX_MSG_MAP(CWinGlkOptionGeneralPage)
	ON_BN_CLICKED(IDC_USE_LINK_COLOUR, OnUseLinkColour)
	ON_BN_CLICKED(IDC_SPEECHDLG, OnSpeechDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CWinGlkOptionGeneralPage::OnInitDialog() 
{
	CWinGlkLogoPage::OnInitDialog();

	CString strOther;
	strOther.LoadString(IDS_OTHER);
	m_Link.SetOtherText(strOther);
	m_Link.SubclassDlgItem(IDC_LINK_COLOUR,this);
	SetControlState();

	return TRUE;
}

void CWinGlkOptionGeneralPage::OnUseLinkColour() 
{
	SetControlState();
}

COLORREF CWinGlkOptionGeneralPage::GetCustomLinkColour(void)
{
	return m_Link.GetCurrentColour();
}

void CWinGlkOptionGeneralPage::SetCustomLinkColour(COLORREF Colour)
{
	m_Link.SetCurrentColour(Colour);
}

void CWinGlkOptionGeneralPage::SetControlState(void)
{
	m_Link.EnableWindow(m_UseLinkColour.GetCheck() != 0);
	m_OpenSpeechDlg.ShowWindow(
		TextToSpeech::GetSpeechEngine().IsAvailable() ? SW_SHOW : SW_HIDE);
}

bool CWinGlkOptionGeneralPage::IsControlTransparent(UINT nID)
{
	switch (nID)
	{
	case IDC_USE_LINK_UNDER:
	case IDC_USE_LINK_COLOUR:
		return TRUE;
	}
	return FALSE;
}

void CWinGlkOptionGeneralPage::OnSpeechDlg() 
{
	CSpeechDlg SpeechDlg;
	SpeechDlg.m_bSpeak = m_bSpeak;
	SpeechDlg.m_VoiceGUID = m_VoiceGUID;

	if (SpeechDlg.DoModal() == IDOK)
	{
		m_bSpeak = SpeechDlg.m_bSpeak;
		m_VoiceGUID = SpeechDlg.m_VoiceGUID;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWinGlkOptionStylePage property sheet
/////////////////////////////////////////////////////////////////////////////

CWinGlkOptionStylePage::CWinGlkOptionStylePage() :
	CWinGlkLogoPage(CWinGlkOptionStylePage::IDD),
 	m_TextBufferStyles(*(CWinGlkWndTextBuffer::GetDefaultStyles())),
	m_TextGridStyles(*(CWinGlkWndTextGrid::GetDefaultStyles()))
{
	//{{AFX_DATA_INIT(CWinGlkOptionStylePage)
	m_bOblique = FALSE;
	m_iJustification = -1;
	m_bProportional = FALSE;
	m_iWeight = -1;
	m_iWindowStyle = -1;
	m_iWindowType = -1;
	m_iIndentation = 0;
	m_iParaIndentation = 0;
	m_iSize = 0;
	m_bReverse = FALSE;
	//}}AFX_DATA_INIT

	m_pStyles = NULL;
	m_iStyle = 0;
}

void CWinGlkOptionStylePage::DoDataExchange(CDataExchange* pDX)
{
	CWinGlkLogoPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinGlkOptionStylePage)
	DDX_Control(pDX, IDC_MESSAGE, m_MessageCtrl);
	DDX_Control(pDX, IDC_WARNICON, m_WarnCtrl);
	DDX_Control(pDX, IDC_TEXT_SIZE, m_Size);
	DDX_Control(pDX, IDC_PARAGRAPH, m_ParaIndent);
	DDX_Control(pDX, IDC_INDENTATION, m_Indent);
	DDX_Check(pDX, IDC_OBLIQUE, m_bOblique);
	DDX_CBIndex(pDX, IDC_JUSTIFICATION, m_iJustification);
	DDX_Check(pDX, IDC_PROPORTIONAL, m_bProportional);
	DDX_CBIndex(pDX, IDC_WEIGHT, m_iWeight);
	DDX_CBIndex(pDX, IDC_WINDOW_STYLE, m_iWindowStyle);
	DDX_CBIndex(pDX, IDC_WINDOW_TYPE, m_iWindowType);
	DDX_Check(pDX, IDC_REVERSE, m_bReverse);
	//}}AFX_DATA_MAP
	DDX_TextNoError(pDX, IDC_INDENTATION, m_iIndentation);
	DDX_TextNoError(pDX, IDC_PARAGRAPH, m_iParaIndentation);
	DDX_TextNoError(pDX, IDC_TEXT_SIZE, m_iSize);
}

BEGIN_MESSAGE_MAP(CWinGlkOptionStylePage, CWinGlkLogoPage)
	//{{AFX_MSG_MAP(CWinGlkOptionStylePage)
	ON_CBN_SELCHANGE(IDC_WINDOW_TYPE, OnChangeWindowType)
	ON_CBN_SELCHANGE(IDC_WINDOW_STYLE, OnChangeStyle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CWinGlkOptionStylePage::OnInitDialog() 
{
	CWinGlkLogoPage::OnInitDialog();

	CString strOther;
	strOther.LoadString(IDS_OTHER);
	m_Text.SetOtherText(strOther);
	m_Back.SetOtherText(strOther);
	m_Text.SubclassDlgItem(IDC_TEXT_COLOUR,this);
	m_Back.SubclassDlgItem(IDC_BACK_COLOUR,this);

	m_Indent.SetLimitText(32);
	m_ParaIndent.SetLimitText(32);
	m_Size.SetLimitText(32);

	SetControlAndMsgState();

	return TRUE;
}

void CWinGlkOptionStylePage::OnChangeWindowType() 
{
	OnChangeStyle();
}

void CWinGlkOptionStylePage::OnChangeStyle() 
{
	UpdateData(TRUE);
	StoreStyleSettings();

	switch (m_iWindowType)
	{
	case 0:
	default:
		SetCurrentStyle(wintype_TextBuffer,m_iWindowStyle);
		break;
	case 1:
		SetCurrentStyle(wintype_TextGrid,m_iWindowStyle);
		break;
	}
	SetControlAndMsgState();
	UpdateData(FALSE);
}

void CWinGlkOptionStylePage::OnOK() 
{
	UpdateData(TRUE);
	StoreStyleSettings();

 	*(CWinGlkWndTextBuffer::GetDefaultStyles()) = m_TextBufferStyles;
	*(CWinGlkWndTextGrid::GetDefaultStyles()) = m_TextGridStyles;

	EndDialog(IDOK);
}

void CWinGlkOptionStylePage::NewStyleValuesToDialog(const CWinGlkStyle& Style)
{
	m_iIndentation = Style.m_Indent;
	m_iParaIndentation = Style.m_ParaIndent;
	m_iSize = Style.m_Size;

	m_bOblique = (Style.m_Oblique) == 1 ? TRUE : FALSE;
	m_bProportional = (Style.m_Proportional) == 1 ? TRUE : FALSE;
	m_bReverse = (Style.m_ReverseColour) == 1 ? TRUE : FALSE;

	switch (Style.m_Justify)
	{
	case stylehint_just_LeftFlush:
	default:
		m_iJustification = 0;
		break;
	case stylehint_just_LeftRight:
		m_iJustification = 1;
		break;
	case stylehint_just_RightFlush:
		m_iJustification = 2;
		break;
	case stylehint_just_Centered:
		m_iJustification = 3;
		break;
	}
	switch (Style.m_Weight)
	{
	case 0:
	default:
		m_iWeight = 0;
		break;
	case 1:
		m_iWeight = 1;
		break;
	case -1:
		m_iWeight = 2;
		break;
	}

	m_Text.SetCurrentColour(CWinGlkWnd::GetColour(Style.m_TextColour));
	if (m_Text.GetSafeHwnd())
		m_Text.Invalidate();
	m_Back.SetCurrentColour(CWinGlkWnd::GetColour(Style.m_BackColour));
	if (m_Back.GetSafeHwnd())
		m_Back.Invalidate();
}

void CWinGlkOptionStylePage::SetCurrentStyle(int iWinType, int iStyle)
{
	switch (iWinType)
	{
	case wintype_TextBuffer:
	default:
		m_iWindowType = 0;
		m_pStyles = &m_TextBufferStyles;
		break;
	case wintype_TextGrid:
		m_iWindowType = 1;
		m_pStyles = &m_TextGridStyles;
		break;
	}
	m_iWindowStyle = iStyle;
	m_iStyle = iStyle;

	if (m_pStyles)
	{
		CWinGlkStyle* pStyle = m_pStyles->GetStyle(iStyle);
		NewStyleValuesToDialog(*pStyle);
	}
}

void CWinGlkOptionStylePage::SetControlAndMsgState(void)
{
	bool bUserEdit = false;
	if (m_pStyles)
	{
		CWinGlkStyle* pStyle = m_pStyles->GetStyle(m_iStyle);
		bUserEdit = pStyle->m_bUserControl;
	}
	bool bAllStyles = (m_iWindowType == 0) && bUserEdit;

	m_Indent.EnableWindow(bAllStyles);
	m_ParaIndent.EnableWindow(bAllStyles);
	m_Size.EnableWindow(bUserEdit && ((m_iWindowType == 0) || (m_iStyle == 0)));
	GetDlgItem(IDC_OBLIQUE)->EnableWindow(bAllStyles);
	GetDlgItem(IDC_JUSTIFICATION)->EnableWindow(bAllStyles);
	GetDlgItem(IDC_PROPORTIONAL)->EnableWindow(bAllStyles);
	GetDlgItem(IDC_WEIGHT)->EnableWindow(bAllStyles);

	GetDlgItem(IDC_REVERSE)->EnableWindow(bUserEdit);
	m_Text.EnableWindow(bUserEdit);
	m_Back.EnableWindow(bUserEdit);

	CString strMessage;
	LPCTSTR Icon;
	if (bUserEdit)
	{
		Icon = IDI_ASTERISK;
		strMessage.LoadString(IDS_STYLE_NOTE);
	}
	else
	{
		Icon = IDI_EXCLAMATION;
		strMessage.LoadString(IDS_STYLE_NOEDIT);
	}
	m_WarnCtrl.SetIcon(AfxGetApp()->LoadStandardIcon(Icon));
	m_MessageCtrl.SetWindowText(strMessage);
}

void CWinGlkOptionStylePage::StoreStyleSettings(void)
{
	if (m_pStyles)
	{
		CWinGlkStyle* pStyle = m_pStyles->GetStyle(m_iStyle);

		pStyle->m_Indent = m_iIndentation;
		pStyle->m_ParaIndent = m_iParaIndentation;
		pStyle->m_Size = m_iSize;

		pStyle->m_Oblique = m_bOblique ? 1 : 0;
		pStyle->m_Proportional = m_bProportional ? 1 : 0;
		pStyle->m_ReverseColour = m_bReverse ? 1 : 0;

		switch (m_iJustification)
		{
		case 0:
		default:
			pStyle->m_Justify = stylehint_just_LeftFlush;
			break;
		case 1:
			pStyle->m_Justify = stylehint_just_LeftRight;
			break;
		case 2:
			pStyle->m_Justify = stylehint_just_RightFlush;
			break;
		case 3:
			pStyle->m_Justify = stylehint_just_Centered;
			break;
		}
		switch (m_iWeight)
		{
		case 0:
		default:
			pStyle->m_Weight = 0;
			break;
		case 1:
			pStyle->m_Weight = 1;
			break;
		case 2:
			pStyle->m_Weight = -1;
			break;
		}

		pStyle->m_TextColour = ColourToGlk(m_Text.GetCurrentColour());
		pStyle->m_BackColour = ColourToGlk(m_Back.GetCurrentColour());
	}
}

int CWinGlkOptionStylePage::ColourToGlk(COLORREF Colour)
{
	CGlkApp* pApp = (CGlkApp*)AfxGetApp();
	int iColour = 0;

	if (Colour == ::GetSysColor(COLOR_WINDOWTEXT))
		iColour = 0xFFFFFFFF;
	else if (Colour == ::GetSysColor(COLOR_WINDOW))
		iColour = 0xFFFFFFFE;
	else
	{
		int r = GetRValue(Colour);
		int g = GetGValue(Colour);
		int b = GetBValue(Colour);

		iColour = (r<<16) | (g<<8) | b;
	}
	return iColour;
}

bool CWinGlkOptionStylePage::IsControlTransparent(UINT)
{
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// CSpeechDlg dialog
/////////////////////////////////////////////////////////////////////////////

CSpeechDlg::CSpeechDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSpeechDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpeechDlg)
	m_bSpeak = FALSE;
	//}}AFX_DATA_INIT
}

void CSpeechDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpeechDlg)
	DDX_Control(pDX, IDC_VOICE, m_Voice);
	DDX_Check(pDX, IDC_SPEAK, m_bSpeak);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSpeechDlg, CDialog)
	//{{AFX_MSG_MAP(CSpeechDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CSpeechDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Get the voice modes
	const TextToSpeech::ModeInfoArray& Modes =
		TextToSpeech::GetSpeechEngine().GetModes();

	// Add the modes to the combo box, and select an entry
	int index = 0;
	for (int i = 0; i < Modes.GetSize(); i++)
	{
		m_Voice.AddString(Modes[i].Name);
		if (Modes[i].Mode == m_VoiceGUID)
			index = i;
	}
	m_Voice.SetCurSel(index);

	return TRUE;
}

void CSpeechDlg::OnOK() 
{
	// Get the voice modes
	const TextToSpeech::ModeInfoArray& Modes =
		TextToSpeech::GetSpeechEngine().GetModes();

	// Store the selected mode
	int index = m_Voice.GetCurSel();
	if (index != CB_ERR)
	{
		if ((index >= 0) && (index < Modes.GetSize()))
			m_VoiceGUID = Modes[index].Mode;
	}

	CDialog::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDialog dialog
/////////////////////////////////////////////////////////////////////////////

CAboutDialog::CAboutDialog(CWnd* pParent) : CWinGlkLogoDlg(CAboutDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAboutDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CAboutDialog::DoDataExchange(CDataExchange* pDX)
{
	CWinGlkLogoDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDialog, CWinGlkLogoDlg)
	//{{AFX_MSG_MAP(CAboutDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
