/////////////////////////////////////////////////////////////////////////////
//
// Windows MFC Glk Libraries
//
// GlkDialogs
// Dialog classes
//
/////////////////////////////////////////////////////////////////////////////

#ifndef WINGLK_DIALOGS_H_
#define WINGLK_DIALOGS_H_

#include "ColourButton.h"
#include "Dib.h"
#include "GlkStyle.h"
#include "Resource.h"

/////////////////////////////////////////////////////////////////////////////
// CScrollBackDlg dialog
/////////////////////////////////////////////////////////////////////////////

class CScrollBackDlg : public CDialog
{
// Construction
public:
	CScrollBackDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CScrollBackDlg)
	enum { IDD = IDD_SCROLLBACK };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScrollBackDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CScrollBackDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnCopy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	CRect m_DialogRect;
	CString m_strScrollback;

protected:
	CRichEditCtrl m_RichEdit;
};

/////////////////////////////////////////////////////////////////////////////
// CWinGlkLogoDlg dialog
/////////////////////////////////////////////////////////////////////////////

class CWinGlkLogoDlg : public CDialog
{
// Construction
public:
	CWinGlkLogoDlg(UINT nIDTemplate, CWnd* pParent = NULL);

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CWinGlkLogoDlg)
	virtual BOOL OnInitDialog();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	DECLARE_MESSAGE_MAP()

protected:
	UINT m_BitmapID;
	CDib m_Dib;
	CBrush m_HollowBrush;
};

/////////////////////////////////////////////////////////////////////////////
// CWinGlkLogoPage property page
/////////////////////////////////////////////////////////////////////////////

class CWinGlkLogoPage : public CPropertyPage
{
// Construction
public:
	CWinGlkLogoPage(UINT nIDTemplate);

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CWinGlkLogoPage)
	virtual BOOL OnInitDialog();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	DECLARE_MESSAGE_MAP()

protected:
	virtual bool IsControlTransparent(UINT nID) = 0;

protected:
	UINT m_BitmapID;
	CDib m_Dib;
	CBrush m_HollowBrush;
};

/////////////////////////////////////////////////////////////////////////////
// CWinGlkOptionGeneralPage property page
/////////////////////////////////////////////////////////////////////////////

class CWinGlkOptionGeneralPage : public CWinGlkLogoPage
{
// Construction
public:
	CWinGlkOptionGeneralPage();   // standard constructor

// Dialog Data
	//{{AFX_DATA(CWinGlkOptionGeneralPage)
	enum { IDD = IDD_OPTIONS_GENERAL };
	CButton	m_OpenSpeechDlg;
	CButton	m_UseLinkColour;
	BOOL	m_bBorders;
	BOOL	m_bLinkColour;
	BOOL	m_bUnderlineColour;
	BOOL	m_bGUI;
	BOOL	m_bStyleHints;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinGlkOptionGeneralPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CWinGlkOptionGeneralPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnUseLinkColour();
	afx_msg void OnSpeechDlg();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	COLORREF GetCustomLinkColour(void);
	void SetCustomLinkColour(COLORREF Colour);

protected:
	void SetControlState(void);
	virtual bool IsControlTransparent(UINT nID);

public:
	BOOL m_bSpeak;
	GUID m_VoiceGUID;

protected:
	CColourButton m_Link;
};

/////////////////////////////////////////////////////////////////////////////
// CWinGlkOptionStylePage property page
/////////////////////////////////////////////////////////////////////////////

class CWinGlkOptionStylePage : public CWinGlkLogoPage
{
// Construction
public:
	CWinGlkOptionStylePage();   // standard constructor

// Dialog Data
	//{{AFX_DATA(CWinGlkOptionStylePage)
	enum { IDD = IDD_OPTIONS_STYLE };
	CStatic	m_MessageCtrl;
	CStatic	m_WarnCtrl;
	CEdit	m_Size;
	CEdit	m_ParaIndent;
	CEdit	m_Indent;
	BOOL	m_bOblique;
	int	m_iJustification;
	BOOL	m_bProportional;
	int	m_iWeight;
	int	m_iWindowStyle;
	int	m_iWindowType;
	BOOL	m_bReverse;
	//}}AFX_DATA
	int	m_iIndentation;
	int	m_iParaIndentation;
	int	m_iSize;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinGlkOptionStylePage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CWinGlkOptionStylePage)
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeWindowType();
	afx_msg void OnChangeStyle();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void SetCurrentStyle(int iWinType, int iStyle);

protected:
	void NewStyleValuesToDialog(const CWinGlkStyle& Style);
	void SetControlAndMsgState(void);
	void StoreStyleSettings(void);
	int ColourToGlk(COLORREF Colour);
	virtual bool IsControlTransparent(UINT nID);

protected:
	CColourButton m_Text;
	CColourButton m_Back;

	CWinGlkStyles m_TextBufferStyles;
	CWinGlkStyles m_TextGridStyles;
	CWinGlkStyles* m_pStyles;
	int m_iStyle;
};

/////////////////////////////////////////////////////////////////////////////
// CSpeechDlg dialog
/////////////////////////////////////////////////////////////////////////////

class CSpeechDlg : public CDialog
{
// Construction
public:
	CSpeechDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSpeechDlg)
	enum { IDD = IDD_SPEECH };
	CComboBox	m_Voice;
	BOOL	m_bSpeak;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSpeechDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSpeechDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	GUID m_VoiceGUID;
};

/////////////////////////////////////////////////////////////////////////////
// CAboutDialog dialog
/////////////////////////////////////////////////////////////////////////////

class CAboutDialog : public CWinGlkLogoDlg
{
// Construction
public:
	CAboutDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAboutDialog)
	enum { IDD = IDD_ABOUT };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAboutDialog)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif // WINGLK_DIALOGS_H_
