/////////////////////////////////////////////////////////////////////////////
//
// Windows MFC Glk Libraries
//
// GlkMainWnd
// Main window of the Glk application
//
/////////////////////////////////////////////////////////////////////////////

#ifndef WINGLK_MAINWND_H_
#define WINGLK_MAINWND_H_

#include "BCMenu.h"
#include "GlkGraphic.h"
#include "Resource.h"
#include "ToolbarEx.h"

/////////////////////////////////////////////////////////////////////////////
// CWinGlkViewWnd window, derived from the base CWnd class
/////////////////////////////////////////////////////////////////////////////

class CWinGlkViewWnd : public CWnd
{
public:
	CWinGlkViewWnd() {};

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinGlkViewWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWinGlkViewWnd() {};

// Generated message map functions
protected:
	//{{AFX_MSG(CWinGlkViewWnd)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void SizeWindows(void);
};

/////////////////////////////////////////////////////////////////////////////
// CWinGlkMainWnd frame window, derived from the CFrameWnd class
/////////////////////////////////////////////////////////////////////////////

class CWinGlkMainWnd : public CFrameWnd
{
public:
	CWinGlkMainWnd();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinGlkMainWnd)
	public:
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWinGlkMainWnd();

	bool Create(bool bFrame);

	void StartTimer(int iMilliSecs);
	void SetBorders(bool bBorders);
	void SetGUI(bool bGUI);
	void EnableScrollback(bool bEnable);

	CWinGlkViewWnd* GetView(void) { return &m_View; };
	void DockControlBar(CControlBar* pBar, bool bLast);
	virtual void GetMessageString(UINT nID, CString& rMessage) const;

	static void SetWindowMask(CWinGlkGraphic* pGraphic);

// Generated message map functions
protected:
	//{{AFX_MSG(CWinGlkMainWnd)
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnSettingChange(UINT uFlags, LPCTSTR lpszSection);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnScrollback();
	afx_msg void OnUpdateScrollback(CCmdUI* pCmdUI);
	afx_msg void OnFontProportional();
	afx_msg void OnFontFixed();
	afx_msg void OnOptions();
	afx_msg void OnAbout();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg LRESULT OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu);
	afx_msg void OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnToolTipText(UINT nID, NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()

protected:
	enum Timer
	{
		PulseTimer = 1,
		GlkTimer
	};

	void ChangeFont(bool bFixed);

protected:
	CWinGlkViewWnd m_View;
	CMenu m_FontMenu;
	BCMenu m_Menus;
	CStatusBar m_StatusBar;
	CToolBarEx m_GlkToolBar;
	CToolBarEx m_UserToolBar;

	static CRgn m_Mask;
};

#endif // WINGLK_MAINWND_H_
