/////////////////////////////////////////////////////////////////////////////
//
// Windows MFC GLK Libraries
//
// GlkSoundMOD
// GLK MOD module sounds
//
/////////////////////////////////////////////////////////////////////////////

#ifndef WINGLK_SOUND_MOD_H_
#define WINGLK_SOUND_MOD_H_

#include "DSoundEngine.h"
#include "GlkSound.h"
#include "mpsndsys.h"

/////////////////////////////////////////////////////////////////////////////
// Class for MOD sound loader
/////////////////////////////////////////////////////////////////////////////

class CWinGlkMODSoundLoader : public CWinGlkSoundLoader
{
public:
	CWinGlkMODSoundLoader() {};
	virtual ~CWinGlkMODSoundLoader() {};

public:
	// Get file prefix for sounds supported by this loader
	virtual LPCTSTR GetFilePrefix(void);

	// Get the file extensions for sounds supported for this loader
	virtual int GetNumberFileExtensions(void);
	virtual LPCTSTR GetFileExtension(int iExtIndex);

	// Get the identifier for sounds supported for this loader
	virtual glui32 GetIdentifier(void);
	
	// Get a sound object
	virtual CWinGlkSound* GetSound(LPCTSTR pszFileName);
	virtual CWinGlkSound* GetSound(BYTE* pData, int iLength);

	// Clean up after sound playback has been stopped
	virtual void SoundStopped(void);
};

/////////////////////////////////////////////////////////////////////////////
// Class for MOD sounds
/////////////////////////////////////////////////////////////////////////////

class CWinGlkMODSound : public CWinGlkSound, public CDSound
{
public:
	CWinGlkMODSound(BYTE* pData, int iLength);
	CWinGlkMODSound(LPCTSTR pszFileName);
	virtual ~CWinGlkMODSound();

	virtual bool Play(int iRepeat, int iVolume);
	virtual bool IsPlaying(void);
	virtual void SetVolume(int iVolume);

	virtual void WriteSampleData(unsigned char* pSample, int iSampleLen);
	virtual bool IsSoundOver(DWORD Tick);
	virtual int GetType(void);

	static void InitMODPlug(void);
	static void CloseMODPlug(void);
	static bool IsMODPlugLoaded(void);

protected:
	// The duration of the sample
	int m_Duration;

	// MODPlug data
	static HINSTANCE m_hMODPlugDLL;
	static IModMixer* m_pMPPAPI;
	static bool m_bShowError;
};

#endif // WINGLK_SOUND_MOD_H_
